import type { IO } from "fp-ts/lib/IO";

export interface Logger {
  info: (message: string) => IO<void>;
  error: (message: string) => IO<void>;
  warn: (message: string) => IO<void>;
}

export const ConsoleLogger: Logger = {
  info: (message: string) => () =>
    console.log(`[${new Date().toUTCString()}] INFO ` + message),
  error: (message: string) => () =>
    console.error(`[${new Date().toUTCString()}] ERROR ` + message),
  warn: (message: string) => () =>
    console.warn(`[${new Date().toUTCString()}] WARN ` + message),
};
